Makefile 9.1 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274
  1. # set the shell to bash always
  2. SHELL := /bin/bash
  3. # set make and shell flags to exit on errors
  4. MAKEFLAGS += --warn-undefined-variables
  5. .SHELLFLAGS := -euo pipefail -c
  6. ARCH = amd64 arm64
  7. BUILD_ARGS ?=
  8. DOCKERFILE ?= Dockerfile
  9. # default target is build
  10. .DEFAULT_GOAL := all
  11. .PHONY: all
  12. all: $(addprefix build-,$(ARCH))
  13. # Image registry for build/push image targets
  14. export IMAGE_REGISTRY ?= ghcr.io
  15. export IMAGE_REPO ?= external-secrets/external-secrets
  16. export IMAGE_NAME ?= $(IMAGE_REGISTRY)/$(IMAGE_REPO)
  17. #Valid licenses for license.check
  18. LICENSES ?= Apache-2.0|MIT|BSD-3-Clause|ISC|MPL-2.0|BSD-2-Clause
  19. BUNDLE_DIR ?= deploy/crds
  20. CRD_DIR ?= config/crds
  21. HELM_DIR ?= deploy/charts/external-secrets
  22. TF_DIR ?= terraform
  23. OUTPUT_DIR ?= bin
  24. # Get the currently used golang install path (in GOPATH/bin, unless GOBIN is set)
  25. ifeq (,$(shell go env GOBIN))
  26. GOBIN=$(shell go env GOPATH)/bin
  27. else
  28. GOBIN=$(shell go env GOBIN)
  29. endif
  30. # check if there are any existing `git tag` values
  31. ifeq ($(shell git tag),)
  32. # no tags found - default to initial tag `v0.0.0`
  33. export VERSION := $(shell echo "v0.0.0-$$(git rev-list HEAD --count)-g$$(git describe --dirty --always)" | sed 's/-/./2' | sed 's/-/./2')
  34. else
  35. # use tags
  36. export VERSION := $(shell git describe --dirty --always --tags --exclude 'helm*' | sed 's/-/./2' | sed 's/-/./2')
  37. endif
  38. TAG_SUFFIX ?=
  39. export IMAGE_TAG ?= $(VERSION)$(TAG_SUFFIX)
  40. # ====================================================================================
  41. # Colors
  42. BLUE := $(shell printf "\033[34m")
  43. YELLOW := $(shell printf "\033[33m")
  44. RED := $(shell printf "\033[31m")
  45. GREEN := $(shell printf "\033[32m")
  46. CNone := $(shell printf "\033[0m")
  47. # ====================================================================================
  48. # Logger
  49. TIME_LONG = `date +%Y-%m-%d' '%H:%M:%S`
  50. TIME_SHORT = `date +%H:%M:%S`
  51. TIME = $(TIME_SHORT)
  52. INFO = echo ${TIME} ${BLUE}[ .. ]${CNone}
  53. WARN = echo ${TIME} ${YELLOW}[WARN]${CNone}
  54. ERR = echo ${TIME} ${RED}[FAIL]${CNone}
  55. OK = echo ${TIME} ${GREEN}[ OK ]${CNone}
  56. FAIL = (echo ${TIME} ${RED}[FAIL]${CNone} && false)
  57. # ====================================================================================
  58. # Conformance
  59. reviewable: generate helm.generate helm.docs lint ## Ensure a PR is ready for review.
  60. @go mod tidy
  61. golicenses.check: ## Check install of go-licenses
  62. @if ! go-licenses >> /dev/null 2>&1; then \
  63. echo -e "\033[0;33mgo-licenses is not installed: run go install github.com/google/go-licenses@latest" ; \
  64. exit 1; \
  65. fi
  66. license.check: golicenses.check
  67. @$(INFO) running dependency license checks
  68. @ok=0; go-licenses csv github.com/external-secrets/external-secrets 2>/dev/null | \
  69. grep -v -E '${LICENSES}' | \
  70. tr "," " " | awk '{print "Invalid License " $$3 " for dependency " $$1 }'|| ok=1; \
  71. if [[ $$ok -eq 1 ]]; then $(OK) dependencies are compliant; else $(FAIL); fi
  72. check-diff: reviewable ## Ensure branch is clean.
  73. @$(INFO) checking that branch is clean
  74. @test -z "$$(git status --porcelain)" || (echo "$$(git status --porcelain)" && $(FAIL))
  75. @$(OK) branch is clean
  76. # ====================================================================================
  77. # Golang
  78. .PHONY: test
  79. test: generate ## Run tests
  80. @$(INFO) go test unit-tests
  81. go test -race -v $(shell go list ./... | grep -v e2e) -coverprofile cover.out
  82. @$(OK) go test unit-tests
  83. .PHONY: test.e2e
  84. test.e2e: generate ## Run e2e tests
  85. @$(INFO) go test e2e-tests
  86. $(MAKE) -C ./e2e test
  87. @$(OK) go test e2e-tests
  88. .PHONY: test.e2e.managed
  89. test.e2e.managed: generate ## Run e2e tests managed
  90. @$(INFO) go test e2e-tests-managed
  91. $(MAKE) -C ./e2e test.managed
  92. @$(OK) go test e2e-tests-managed
  93. .PHONY: build
  94. build: $(addprefix build-,$(ARCH)) ## Build binary
  95. .PHONY: build-%
  96. build-%: generate ## Build binary for the specified arch
  97. @$(INFO) go build $*
  98. @CGO_ENABLED=0 GOOS=linux GOARCH=$* \
  99. go build -o '$(OUTPUT_DIR)/external-secrets-linux-$*' main.go
  100. @$(OK) go build $*
  101. lint.check: ## Check install of golanci-lint
  102. @if ! golangci-lint --version > /dev/null 2>&1; then \
  103. echo -e "\033[0;33mgolangci-lint is not installed: run \`\033[0;32mmake lint.install\033[0m\033[0;33m\` or install it from https://golangci-lint.run\033[0m"; \
  104. exit 1; \
  105. fi
  106. lint.install: ## Install golangci-lint to the go bin dir
  107. @if ! golangci-lint --version > /dev/null 2>&1; then \
  108. echo "Installing golangci-lint"; \
  109. curl -sSfL https://raw.githubusercontent.com/golangci/golangci-lint/master/install.sh | sh -s -- -b $(GOBIN) v1.49.0; \
  110. fi
  111. lint: lint.check ## Run golangci-lint
  112. @if ! golangci-lint run --timeout 5m; then \
  113. echo -e "\033[0;33mgolangci-lint failed: some checks can be fixed with \`\033[0;32mmake fmt\033[0m\033[0;33m\`\033[0m"; \
  114. exit 1; \
  115. fi
  116. @$(OK) Finished linting
  117. fmt: lint.check ## Ensure consistent code style
  118. @go mod tidy
  119. @go fmt ./...
  120. @golangci-lint run --fix > /dev/null 2>&1 || true
  121. @$(OK) Ensured consistent code style
  122. generate: ## Generate code and crds
  123. @./hack/crd.generate.sh $(BUNDLE_DIR) $(CRD_DIR)
  124. @$(OK) Finished generating deepcopy and crds
  125. # ====================================================================================
  126. # Local Utility
  127. # This is for running out-of-cluster locally, and is for convenience.
  128. # For more control, try running the binary directly with different arguments.
  129. run: generate ## Run app locally (without a k8s cluster)
  130. go run ./main.go
  131. manifests: helm.generate ## Generate manifests from helm chart
  132. mkdir -p $(OUTPUT_DIR)/deploy/manifests
  133. helm template external-secrets $(HELM_DIR) -f deploy/manifests/helm-values.yaml > $(OUTPUT_DIR)/deploy/manifests/external-secrets.yaml
  134. crds.install: generate ## Install CRDs into a cluster. This is for convenience
  135. kubectl apply -f $(BUNDLE_DIR)
  136. crds.uninstall: ## Uninstall CRDs from a cluster. This is for convenience
  137. kubectl delete -f $(BUNDLE_DIR)
  138. # ====================================================================================
  139. # Helm Chart
  140. helm.docs: ## Generate helm docs
  141. @cd $(HELM_DIR); \
  142. docker run --rm -v $(shell pwd)/$(HELM_DIR):/helm-docs -u $(shell id -u) jnorwood/helm-docs:v1.5.0
  143. HELM_VERSION ?= $(shell helm show chart $(HELM_DIR) | grep 'version:' | sed 's/version: //g')
  144. helm.build: helm.generate ## Build helm chart
  145. @$(INFO) helm package
  146. @helm package $(HELM_DIR) --dependency-update --destination $(OUTPUT_DIR)/chart
  147. @mv $(OUTPUT_DIR)/chart/external-secrets-$(HELM_VERSION).tgz $(OUTPUT_DIR)/chart/external-secrets.tgz
  148. @$(OK) helm package
  149. helm.generate:
  150. ./hack/helm.generate.sh $(BUNDLE_DIR) $(HELM_DIR)
  151. @$(OK) Finished generating helm chart files
  152. # ====================================================================================
  153. # Documentation
  154. .PHONY: docs
  155. docs: generate ## Generate docs
  156. $(MAKE) -C ./hack/api-docs build
  157. .PHONY: docs.publish
  158. docs.publish: generate ## Generate and deploys docs
  159. $(MAKE) -C ./hack/api-docs build.publish
  160. .PHONY: docs.serve
  161. docs.serve: ## Serve docs
  162. $(MAKE) -C ./hack/api-docs serve
  163. # ====================================================================================
  164. # Build Artifacts
  165. build.all: docker.build helm.build ## Build all artifacts (docker image, helm chart)
  166. docker.image:
  167. @echo $(IMAGE_NAME):$(IMAGE_TAG)
  168. docker.tag:
  169. @echo $(IMAGE_TAG)
  170. docker.build: $(addprefix build-,$(ARCH)) ## Build the docker image
  171. @$(INFO) docker build
  172. @docker build -f $(DOCKERFILE) . $(BUILD_ARGS) -t $(IMAGE_NAME):$(IMAGE_TAG)
  173. @$(OK) docker build
  174. docker.push: ## Push the docker image to the registry
  175. @$(INFO) docker push
  176. @docker push $(IMAGE_NAME):$(IMAGE_TAG)
  177. @$(OK) docker push
  178. # RELEASE_TAG is tag to promote. Default is promoting to main branch, but can be overriden
  179. # to promote a tag to a specific version.
  180. RELEASE_TAG ?= $(IMAGE_TAG)
  181. SOURCE_TAG ?= $(VERSION)$(TAG_SUFFIX)
  182. docker.promote: ## Promote the docker image to the registry
  183. @$(INFO) promoting $(SOURCE_TAG) to $(RELEASE_TAG)
  184. docker manifest inspect $(IMAGE_NAME):$(SOURCE_TAG) > .tagmanifest
  185. for digest in $$(jq -r '.manifests[].digest' < .tagmanifest); do \
  186. docker pull $(IMAGE_NAME)@$$digest; \
  187. done
  188. docker manifest create $(IMAGE_NAME):$(RELEASE_TAG) \
  189. $$(jq -j '"--amend $(IMAGE_NAME)@" + .manifests[].digest + " "' < .tagmanifest)
  190. docker manifest push $(IMAGE_NAME):$(RELEASE_TAG)
  191. @$(OK) docker push $(RELEASE_TAG) \
  192. # ====================================================================================
  193. # Terraform
  194. tf.plan.%: ## Runs terrform plan for a provider
  195. @cd $(TF_DIR)/$*; \
  196. terraform init; \
  197. terraform plan
  198. tf.apply.%: ## Runs terrform apply for a provider
  199. @cd $(TF_DIR)/$*; \
  200. terraform init; \
  201. terraform apply -auto-approve
  202. tf.destroy.%: ## Runs terrform destroy for a provider
  203. @cd $(TF_DIR)/$*; \
  204. terraform init; \
  205. terraform destroy -auto-approve
  206. tf.show.%: ## Runs terrform show for a provider and outputs to a file
  207. @cd $(TF_DIR)/$*; \
  208. terraform init; \
  209. terraform plan -out tfplan.binary; \
  210. terraform show -json tfplan.binary > plan.json
  211. # ====================================================================================
  212. # Help
  213. # only comments after make target name are shown as help text
  214. help: ## Displays this help message
  215. @echo -e "$$(grep -hE '^\S+:.*##' $(MAKEFILE_LIST) | sed -e 's/:.*##\s*/:/' -e 's/^\(.\+\):\(.*\)/\\x1b[36m\1\\x1b[m:\2/' | column -c2 -t -s : | sort)"